VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PortMapperCBs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
'=============
'PortMapperCBs
'=============
'
'Implements callback interface required by PortMapper for doing
'UPnP DeviceFinder calls.
'
'NOTE: COMPILING ON WINDOWS XP INSTEAD OF VISTA OR LATER
'
'   The Windows XP version of the upnp.dll does not currently
'   expose the full set of COM interfaces in its type information.
'   To use this code (i.e. to compile) under Windows XP you must
'   set the conditional compilation constant XP_COMPILE = True
'   AND MANUALLY COMMENT OUT THE IMPLEMENTS STATEMENT BELOW!
'
'   This results in the use of the late-bound IDispatch "VBScript"
'   callback mechanism instead of the early-bound mechanism.
'
'   Programs compiled either way should run properly either on
'   old systems (Windows XP) or newer ones.  The "XP compile"
'   approach should work when compiling on Vista or later as well.
'
'   It may be slightly more optimal to compile under Vista or
'   later *AFTER* you set XP_COMPILE = False and un-comment the
'   Implements statement below.  This also makes lFindData
'   available making it easier to manage multiple simultaneous
'   searches in more advanced scenarios.
'

#Const XP_COMPILE = True
'NOTE: Must manually comment this statement out for an XP compile:
'Implements UPNPLib.IUPnPDeviceFinderCallback

Public Event DeviceAdded(ByVal Device As UPNPLib.IUPnPDevice)
Public Event DeviceRemoved(ByVal UDN As String)
Public Event SearchComplete()

#If XP_COMPILE Then
    Public Sub IDispatchCallback( _
        ByVal pDevice As Variant, _
        ByVal bstrUDN As Variant, _
        ByVal lType As Variant)
Attribute IDispatchCallback.VB_UserMemId = 0
        'NOTE: Must be dispID = 0, i.e. the default method of the class.
    
        Select Case lType
            Case 0
                RaiseEvent DeviceAdded(pDevice)
            Case 1
                RaiseEvent DeviceRemoved(bstrUDN)
            Case 2
                RaiseEvent SearchComplete
        End Select
    End Sub
#Else
    Private Sub IUPnPDeviceFinderCallback_DeviceAdded( _
        ByVal lFindData As Long, _
        ByVal pDevice As UPNPLib.IUPnPDevice)
        
        RaiseEvent DeviceAdded(pDevice)
    End Sub
    
    Private Sub IUPnPDeviceFinderCallback_DeviceRemoved( _
        ByVal lFindData As Long, _
        ByVal bstrUDN As String)
        
        RaiseEvent DeviceRemoved(bstrUDN)
    End Sub
    
    Private Sub IUPnPDeviceFinderCallback_SearchComplete(ByVal lFindData As Long)
        RaiseEvent SearchComplete
    End Sub
#End If
